<script setup lang="ts">
import { computed, reactive } from "vue";
import { type BucketOut, BucketType } from "@/client";
import SearchUserModal from "@/components/modals/SearchUserModal.vue";
import type { UserOut as User } from "@/client";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { useBucketStore } from "@/stores/buckets";
import { useNameStore } from "@/stores/names";
import { filesize } from "filesize";
import dayjs from "dayjs";
import UpdateBucketLimitsModal from "@/components/admin/UpdateBucketLimitsModal.vue";

const bucketState = reactive<{
  buckets: BucketOut[];
  ownerId: string;
  loading: boolean;
  searched: boolean;
  filterString: string;
  updateLimitsBucket: BucketOut;
}>({
  buckets: [],
  ownerId: "",
  loading: false,
  searched: false,
  filterString: "",
  updateLimitsBucket: {
    name: "",
    description: "",
    owner_id: "",
    public: false,
    created_at: 0,
  },
});

const bucketRepository = useBucketStore();
const nameRepository = useNameStore();

const updateLimitsModalId = "admin-update-bucket-limits-modal";

const filteredBuckets = computed<BucketOut[]>(() =>
  bucketState.buckets.filter((bucket) =>
    bucket.name.includes(bucketState.filterString),
  ),
);

function updateUser(user: User) {
  bucketState.ownerId = user.uid;
}

function resetForm() {
  bucketState.ownerId = "";
  bucketState.filterString = "";
  bucketState.buckets = [];
  bucketState.searched = false;
}

function searchBuckets() {
  bucketState.loading = true;
  bucketRepository
    .fetchBuckets(
      bucketState.ownerId ? bucketState.ownerId : undefined,
      BucketType.OWN,
    )
    .then((buckets) => {
      bucketState.buckets = buckets;
    })
    .finally(() => {
      bucketState.loading = false;
      bucketState.searched = true;
    });
}

function limitsUpdated(bucket: BucketOut) {
  const bucketIndex = bucketState.buckets.findIndex(
    (b) => b.name == bucket.name,
  );
  if (bucketIndex > -1) {
    bucketState.buckets[bucketIndex] = bucket;
  }
}
</script>

<template>
  <search-user-modal
    modal-id="admin-bucket-search-user-modal"
    @user-found="updateUser"
  />
  <update-bucket-limits-modal
    :bucket="bucketState.updateLimitsBucket"
    :modal-id="updateLimitsModalId"
    @updated-limits="limitsUpdated"
  />
  <div class="border-bottom mb-4">
    <h2>Manage Buckets</h2>
  </div>
  <form @submit.prevent="searchBuckets" id="admin-bucket-search-form">
    <div class="d-flex justify-content-evenly align-content-center mb-4">
      <div class="flex-fill mx-2">
        <label for="admin-bucket-name-search" class="form-label"
          >Name of bucket</label
        >
        <div class="input-group">
          <div class="input-group-text">
            <font-awesome-icon icon="fa-solid fa-magnifying-glass" />
          </div>
          <input
            id="admin-bucket-name-search"
            type="text"
            class="form-control"
            placeholder="Search Buckets"
            maxlength="32"
            v-model.trim="bucketState.filterString"
          />
        </div>
      </div>
      <div class="flex-fill mx-2">
        <label for="admin-bucket-user-search" class="form-label"
          >Name of the owner</label
        >
        <div class="input-group">
          <div class="input-group-text">
            <font-awesome-icon icon="fa-solid fa-user" />
          </div>
          <input
            id="admin-bucket-user-search"
            type="text"
            class="form-control"
            readonly
            :value="nameRepository.getName(bucketState.ownerId)"
            placeholder="Search for owner"
            data-bs-toggle="modal"
            data-bs-target="#admin-bucket-search-user-modal"
          />
        </div>
      </div>
    </div>
    <button
      type="submit"
      class="btn btn-primary w-fit"
      :disabled="bucketState.loading"
    >
      Search
    </button>
    <button
      type="button"
      class="btn-primary btn w-fit ms-4"
      :disabled="bucketState.loading"
      @click="resetForm"
    >
      Reset
    </button>
  </form>
  <table class="table table-striped align-middle" v-if="bucketState.buckets">
    <thead>
      <tr>
        <th scope="col"><b>Name</b></th>
        <th scope="col" class="description-column">Description</th>
        <th scope="col">Created at</th>
        <th scope="col">Size Quota</th>
        <th scope="col">Object Quota</th>
        <th scope="col">Owner</th>
        <th scope="col"></th>
      </tr>
    </thead>
    <tbody v-if="filteredBuckets.length === 0">
      <tr>
        <td colspan="7" class="text-center fst-italic fw-light">
          <template v-if="bucketState.searched"
            >No bucket found with specified filters
          </template>
          <template v-else>Select a filter and search for buckets</template>
        </td>
      </tr>
    </tbody>
    <tbody v-else>
      <tr v-for="bucket in filteredBuckets" :key="bucket.name">
        <th scope="row">{{ bucket.name }}</th>
        <td class="description-column">{{ bucket.description }}</td>
        <td>
          {{ dayjs.unix(bucket.created_at).format("DD.MM.YYYY HH:mm:ss") }}
        </td>
        <td>
          <span v-if="bucket.size_limit">
            {{ filesize(1024 * bucket.size_limit) }}
          </span>
          <span v-else>-</span>
        </td>
        <td>
          <span v-if="bucket.object_limit">
            {{ bucket.object_limit }}
          </span>
          <span v-else>-</span>
        </td>
        <td>{{ nameRepository.getName(bucket.owner_id) }}</td>
        <td>
          <button
            type="button"
            class="btn btn-secondary btn-sm"
            @click="bucketState.updateLimitsBucket = bucket"
            data-bs-toggle="modal"
            :data-bs-target="'#' + updateLimitsModalId"
          >
            Edit quotas
          </button>
        </td>
      </tr>
    </tbody>
  </table>
</template>

<style scoped>
.description-column {
  word-break: break-all;
  max-width: 400px;
}
</style>
